"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var chalk_1 = __importDefault(require("chalk"));
var enquirer_1 = require("enquirer");
var exec_sh_1 = require("exec-sh");
var transforms_1 = require("./utils/transforms");
var getTransformPrompt = function (transforms) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new enquirer_1.AutoComplete({
                    message: 'Select which codemod would you like to run? 🤔',
                    limit: 18,
                    choices: transforms.map(function (_a) {
                        var dir = _a.dir;
                        return path_1.default.basename(dir);
                    }),
                    result: function (choice) { return transforms.find(function (_a) {
                        var dir = _a.dir;
                        return dir.includes(choice);
                    }); },
                }).run()];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
var codemodChoice = [
    {
        name: 'path',
        message: 'PATH',
    },
    {
        name: 'parser',
        message: '--parser',
        hint: "default: ".concat(chalk_1.default.cyan('babel')),
    },
    {
        name: 'extensions',
        message: '--extensions',
        hint: "default: ".concat(chalk_1.default.cyan('js')),
    },
    {
        name: 'ignorePattern',
        message: '--ignore-pattern',
    },
];
var getTransformForm = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new enquirer_1.Form({
                    name: 'jscodeshift',
                    message: "Please provide the following jscodeshift cli options ".concat(chalk_1.default.cyan('<https://github.com/facebook/jscodeshift#usage-cli>')),
                    hint: chalk_1.default.bold(chalk_1.default.red('**NOTE**: [PATH] is mandatory option. It is the source code directory eg. /project/src')),
                    choices: codemodChoice,
                }).run()];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
var getPluginsForm = function () { return __awaiter(void 0, void 0, void 0, function () {
    var result;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new enquirer_1.List({
                    name: 'plugins',
                    message: 'Specify any plugins you which to use (multiple can be specified separated with `,`)',
                }).run()];
            case 1:
                result = _a.sent();
                return [2 /*return*/, result];
        }
    });
}); };
var codemods = function () { return __awaiter(void 0, void 0, void 0, function () {
    var transforms, transform, transformPath, form, plugins, args, command;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                transforms = (0, transforms_1.getTransforms)();
                if (transforms.length === 0) {
                    return [2 /*return*/, console.warn(chalk_1.default.red('No codemods available right now.'))];
                }
                return [4 /*yield*/, getTransformPrompt(transforms)];
            case 1:
                transform = _a.sent();
                transformPath = (0, transforms_1.getTransformPath)(transform);
                return [4 /*yield*/, getTransformForm()];
            case 2:
                form = _a.sent();
                return [4 /*yield*/, getPluginsForm()];
            case 3:
                plugins = _a.sent();
                args = __spreadArray(__spreadArray([
                    // Limit CPUs to 8 to prevent issues when running on CI with a large amount of cpus
                    '--cpus=8',
                    form.parser && "--parser=".concat(form.parser),
                    form.extensions && "--extensions=".concat(form.extensions),
                    form.ignorePattern && "--ignore-pattern=".concat(form.ignorePattern)
                ], plugins.map(function (path) { return "--plugin=\"".concat(path, "\""); }), true), [
                    form.others,
                    "--transform=".concat(transformPath),
                    form.path,
                ], false).filter(function (arg) { return !!arg; });
                command = __spreadArray(['node', require.resolve('.bin/jscodeshift')], args, true).join(' ');
                console.log(chalk_1.default.green("Running codemod '".concat(chalk_1.default.bold(path_1.default.basename(transform.dir)), "' with command:\n'").concat(chalk_1.default.bold(command), "'...")));
                return [4 /*yield*/, (0, exec_sh_1.promise)(command)];
            case 4:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.default = codemods;
//# sourceMappingURL=codemods.js.map