"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTransforms = exports.getTransformPath = void 0;
var path_1 = require("path");
var app_root_path_1 = __importDefault(require("app-root-path"));
var glob_1 = __importDefault(require("glob"));
/**
 * Local run is defined as running in ts-node.
 */
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore
var isLocalRun = typeof process[Symbol.for('ts-node.register.instance')] === 'object';
var basePath = (0, path_1.join)(isLocalRun ? app_root_path_1.default.path : process.cwd(), 'node_modules', '@compiled', 'codemods', isLocalRun ? 'src' : 'dist', 'transforms');
var parseTransformPath = function (transformPath) { return (0, path_1.parse)(transformPath); };
var getTransformPath = function (_a) {
    var dir = _a.dir, base = _a.base;
    return (0, path_1.join)(dir, base);
};
exports.getTransformPath = getTransformPath;
var getTransforms = function () {
    return [(0, path_1.join)(basePath, '*', 'index.@(ts|tsx|js)')]
        .flatMap(function (transform) { return glob_1.default.sync(transform); })
        .map(function (transform) { return parseTransformPath(transform); })
        .sort(function (prevParsedPath, nextParsedPath) { return prevParsedPath.dir.localeCompare(nextParsedPath.dir); });
};
exports.getTransforms = getTransforms;
//# sourceMappingURL=transforms.js.map